<?php
/*-------------------------------------------------------+
| PHPFusion Content Management System
| Copyright (C) PHP Fusion Inc
| https://phpfusion.com/
+--------------------------------------------------------+
| Filename: theme_switcher_panel.php
| original author: RobiNN
| CoAuthor: karrak
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
defined('IN_FUSION') || exit;

if (file_exists(INFUSIONS.'theme_switcher_panel/locale/'.LANGUAGE.'.php')) {
    $locale = fusion_get_locale('', INFUSIONS.'theme_switcher_panel/locale/'.LANGUAGE.'.php');
} else {
    $locale = fusion_get_locale('', INFUSIONS.'theme_switcher_panel/locale/English.php');
}

$themes = makefilelist(THEMES, '.|..|templates|admin_themes', TRUE, 'folders');
$userdata = fusion_get_userdata();

if (!empty(session_get(COOKIE_PREFIX.'theme'))) {
    $theme = session_get(COOKIE_PREFIX.'theme');
} else if (!empty($userdata['user_theme'])) {
    $theme = $userdata['user_theme'];
} else {
    $theme = fusion_get_settings('theme');
}

if ($theme == 'Default') {
    $theme = fusion_get_settings('theme');
}

if (check_post('change')) {
    $theme = sanitizer('theme', $theme, 'theme');
    $user = sanitizer('theme_user', '', 'theme_user');
    if (fusion_safe()) {
        if (fusion_get_settings('userthemes') == 1 && check_post('change_theme') && $user == $userdata) {
            if(iMEMBER) {
                dbquery("UPDATE ".DB_USERS." SET user_theme = :theme WHERE user_id = :userid", [':theme' => $theme, ':userid' => $userdata]);
            }
        }

        session_add(COOKIE_PREFIX.'theme', $theme);
        addNotice('success', $locale['TS_02']);
        redirect(FUSION_REQUEST);
    }
}

openside($locale['TS_01']);

add_to_jquery('
    $("#theme").bind("change", function () {
        $("#theme_preview").error(function() {
            $("#theme_preview").attr("src", "'.get_image('imagenotfound').'");
        });

        $("#theme_preview").attr("src", "'.THEMES.'" + $(this).val() + "/screenshot.png");
    });
');

if (file_exists(THEMES.$theme.'/screenshot.png')) {
    echo "<img id='theme_preview' class='img-responsive m-b-15' style='max-height:200px' src='".THEMES.$theme."/screenshot.png'>";
} else {
    echo '<img id="theme_preview" class="img-responsive m-b-15" src="'.get_image('imagenotfound').'" alt="'.$theme.'">';
}


array_unshift($themes, "Default");
$opts = [];
foreach ($themes as $file) {
    $opts[$file] = $file;
}

echo openform('themeswitcher', 'post', FUSION_SELF);
echo form_hidden('theme_user', '', $userdata);
echo form_select('theme', '', $theme, [
    'inline'         => TRUE,
    'options'        => $opts,
        'width'          => '100%',
    'callback_check' => 'theme_exists'
]);

echo form_checkbox('change_theme', $locale['TS_03'], '', ['toggle' => TRUE, 'deactivate' => (fusion_get_settings('userthemes') == 1 ? FALSE : TRUE)]);
echo form_button('change', $locale['TS_04'], $locale['TS_04']);
echo closeform();
closeside();
